*! version 3.1.0  7-Oct-93.
program define mcz /* essentially reproduces mcc.ado with cosmetic changes */
	version 3.0
	local varlist "req ex min(2) max(2)"
	local if "opt"
	local in "opt"
	local weight "fweight"
	#delimit ;
	local options "Level(integer $S_level) TB EXTra EXAct CC
		Alab(string) Blab(string) Plab(string) Nlab(string)" ;
	#delimit cr
	parse "`*'"
	parse "`varlist'", parse(" ")
	local excas `1'
	local excon `2'
	tempvar use WGT one
	quietly { 
		gen byte `use'=1 `if' `in'
		replace `use'=0 if `excas'==. | `excon'==. | `use'==.
		if "`weight'"!="" { 
			gen double `WGT' `exp' if `use'
			replace `use'=0 if `WGT'==.
			capture assert `WGT'>=0 & `WGT'==int(`WGT') if `use'
			if _rc { 
				noisily di in red /*
				*/ "`WGT' negative or noninteger"
				exit 499
			}
			local w "[fweight=`WGT']"
		}
	}

	quietly { 
		gen byte `one'=1
		safesum `one' `w' if `excas' & `excon' & `use'
		local a=$S_1
		safesum `one' `w' if `excas' & `excon'==0 & `use'
		local b=$S_1
		safesum `one' `w' if `excas'==0 & `excon' & `use'
		local c=$S_1
		safesum `one' `w' if `excas'==0 & `excon'==0 & `use'
		local d=$S_1
	}
	if "`alab'"=="" {
		local alab : variable label `excas'
		if "`alab'"=="" { local alab "`excas'" }
	}
	if "`blab'"=="" {
		local blab : variable label `excon'
		if "`blab'"=="" { local blab "`excon'" }
	}
	if "`plab'"=="" { local plab "Non-zero" }
	if "`nlab'"=="" { local nlab "Zero" }
	mczi `a' `b' `c' `d', level(`level') `tb' `extra' `exact' `cc' /*
	 */ alab("`alab'") blab("`blab'") plab("`plab'") nlab("`nlab'")
end
