*! version 1.2.0 PR 20Dec1999.
program define centdlg
	version 6

	precmd centdlg
	global D_sm1 "Data variable"
	global D_sm2 "Group var (optional)"
	global D_sm3 "Confidence level"
	global D_sm4 "Centile(s)"

	getnv			/* get numeric varlist */
	global D_sm5 "$S_1"
	getiv			/* get integer varlist */
	global D_sm6 "$S_1"

	window control static D_sm1  10 10 50 10
	window control msimple D_sm5 10 20 56 60 D_var

	window control static D_sm2  85 10 80 10
	window control ssimple D_sm6 85 20 56 60 D_var2
	
	window control static D_sm4 5 80 60 8 left
	window control edit        68 80 60 8 D_cent

	window control static D_sm3 5 90 60 8 left
	window control edit        68 90 20 8 D_level

	window control button "OK"       5 107 30 16 D_b3
	window control button "Cancel"  40 107 30 16 D_b4
	window control button "Help"    75 107 30 16 D_b5 help
	window control button "Example" 110 107 30 16 D_smp

	global D_b3 "noi centok"
	global D_b4 "exit 3000"
	global D_b5 "whelp centdlg"
	global D_smp "whelp centsmp"

	noi capture window dialog "Centiles" . . 155 140
end

program define centok
	if "$D_level"=="" { global D_level 95 }
	if "$D_cent"=="" {	
		global D_cent 50
	}
	local varlist $D_var
	errnull "`varlist'" "Data variable(s)"
	errvar "$D_var"
	errrange "$D_level" "Confidence level" 10 99 "" int
	parse "$D_cent", parse(" ")
	while "`1'"!="" {
		errrange `1' "Centile" 0 100 =
		mac shift
	}
	if "$D_var2"!="" { local byv "byvar ${D_var2}: " }
	di in wh "`byv'centile `varlist', level($D_level) centile($D_cent)"
	window push `byv'centile `varlist', level($D_level) centile($D_cent)
	`byv'centile `varlist', level($D_level) centile($D_cent)
	exit 3000
end
