*! version 1.0.2  11jan99 arb/pr
program define egendlg
	version 5.0

	precmd egendlg
	global D_sm1 "Data variable(s)"
	global D_sm2 "By variable(s) - optional"
	global D_sm3 "Operation"
	global D_sm4 "New variable:"

	window control static D_sm1 50 10 70 8 left
	window control msimple D_vl 50 20 70 60 D_var

	window control static D_sm3 5 10 40 8 left
	window control ssimple D_fl 5 20 40 60 D_fcn

	window control static D_sm2 130 10 70 8 left
	window control msimple D_vl 130 20 70 60 D_by

	window control static D_sm4 5 90 49 8 left
	window control edit 55 90 40 9 D_new
	global D_new

	getnv
	global D_vl "$S_1"
	global D_fl "count mean median min max sd sum rank std rsum rmean rsd robs rmiss "

	window control button "OK"     43 110 30 16 D_b1
	window control button "Cancel" 93 110 30 16 D_b2
	window control button "Help"  143 110 30 16 D_b3 help

	global D_b1 "egenok"
	global D_b2 "exit 3000"
	global D_b3 "whelp egendlg"

	cap noi window dialog "Extended generate" . . 210 145
end

program define egenok
	version 5.0
	global D_by = trim("$D_by")
	global D_var = trim("$D_var")
	global D_fcn = trim("$D_fcn")
	local fcn = index("$D_fl","$D_fcn ")
	local wc1: word count $D_var
	if `wc1'!=1 & `fcn'<41 {
		window stopbox stop "Please specify one data variable"
	}
	else if `wc1'<2 & `fcn'>40 & `fcn'<56 {
		window stopbox stop "Please specify at least two data variables"
	}
	else if `wc1'<1 {
		window stopbox stop "Please specify at least one data variable"
	}
	errvar "$D_var $D_by"
	local wc1: word count $D_new
	if `wc1'!=1 {
		window stopbox stop "Please specify one new variable"
	}
	cap confirm new variable $D_new
	if _rc {
		window stopbox stop "$D_new already exists"
	}
	errnull "$D_fcn" "An operation"
	if `fcn'==0 {
		window stopbox stop "You have not specified a valid operation"
	}
	if `fcn'>32 & "$D_by"!="" {
		window stopbox stop "By variable option not allowed with $D_fcn"
	}
	if "$D_by" != "" {
		local by ", by($D_by)"
	}
	noi di in white "egen $D_new = $D_fcn($D_var) `by'"
	window push egen $D_new = $D_fcn($D_var) `by'
	noi egen $D_new = $D_fcn($D_var) `by'
	exit 3001
end
