*! version 1.1.1  30Oct98 arb/pr
program define sfrandlg
	version 5.0
	
	precmd sfrandlg
	global D_sm1 "Data variables:"
	global D_sm2 "Account for (optional):"
	
	getnv
	global D_sm5 "$S_1"
	
	window control static D_sm1 10 5 65 10  
	window control msimple D_sm5 10 15 66 52 D_vlist

	window control static D_sm2 80 5 65 10  
	window control msimple D_sm5 80 15 66 52 D_adj
	
	window control check "Store residuals" 10 70 60 9 D_res
	window control check "Normal plot"     80 70 60 9 D_plt

      	window control button "OK"       10 84 30 16 D_bok
	window control button "Cancel"   46 84 30 16 D_bex
	window control button "Help"     82 84 30 16 D_bhl help
	window control button "Example"  116 84 30 16 D_smp
	
	global D_bhl "whelp sfrandlg"
	global D_smp "whelp sfransmp"
	global D_bok "noi ptntok"
	global D_bex "exit 3000"
	
	global D_res 0
	global D_plt 0

	noi cap window dialog "Normality test" . . 160 120
end

program define ptntok
	version 5.0
	errnull "$D_vlist" "A variable"
	if _rc==1 { exit }
	if "$D_adj"!="" {
		local adj "accountfor($D_adj)"
	}
	if $D_res {
		local res "residuals"
	}
	if $D_plt {
		local plt "plot"
	}
	if "`adj'`res'`plt'"!="" {
		local opts ",`adj' `res' `plt'"
	}
	noi di in white _n ". sfranadj $D_vlist`opts'"
	window push sfranadj $D_vlist`opts'
	noi sfranadj $D_vlist`opts'
	exit 3000
end
