*! version 3.0.2 PR 25-May-94.
program define bartlett
	version 3.0
	local varlist "req ex min(1) max(1)"
	local if "opt"
	local in "opt"
	local options "BY(string)"
	parse "`*'"
	if "`by'"=="" {
		di in red "by() required"
		exit 198
	}
	parse "`varlist'", parse(" ")
	tab `by' `if' `in', sum(`1') stand freq
	qui oneway `1' `by' `if' `in'
	local chisq = _result(10)
	local df = _result(11)
	di in gr _n "Bartlett's test for equality of variances" /*
		 */ _n _dup(41) "-"
	if `df'>0 {
		#delimit ;
		di in gr "Chi-square =" in ye %8.3f `chisq'
			in gr ", degrees of freedom = " in ye `df'
			in gr ", P =" in ye %6.3f chiprob(`df', `chisq')
			in gr " (" in ye _result(1) in gr " observations)." ;
		#delimit cr
	}
	else di in gr "Zero degrees of freedom for test."
end
