*! v 1.0.0 PR 26Oct95.
program define _jprcout /* contrast output module */
local yvar "`1'"
local group "`2'"
local obs `3'
local L `4'
local seL `5'
local lower `6'
local upper `7'
local t `8'
local P `9'
local vratio `10'
local Pgrp `11'
local rdf `12'
local rsd `13'
local level `14'

local skip = 8 - length("`yvar'")
local fmt : format `yvar'
if substr("`fmt'",-1,1)=="f" { 
	local ofmt="%9."+substr("`fmt'",-2,2)
}
else	local ofmt "%9.0g"
#delimit ;
di in gr _n
"Variable |     Obs     Contrast    Std. Err.       [`level'% Conf. Interval]" 
_n 
"         |                  (L)       SE(L)"
_n "---------+" _dup(61) "-" ;

di in gr _skip(`skip') "`yvar' |" _col(10)
	in yel %8.0f `obs'
 	_col(23) `ofmt' `L'
 	_col(35) `ofmt' `seL'
 	_col(51) `ofmt' `lower'
 	_col(63) `ofmt' `upper' ;
di _n in gr "Hypothesis test of contrast = 0 (L = 0):"
	_col(43) "t = " %7.3f in ye `t'
	in gr ", P = " %7.4f in ye `P' ;
di _n in gr "Hypothesis test of equal `group' means:"
	_col(43) "F = " %7.3f in ye `vratio'
	in gr ", P = " %7.4f in ye `Pgrp' ;
di _n in gr "Residual SD (with " in ye `rdf'
	in gr " df) from analysis of variance = " in ye `rsd' ;
#delimit cr
end
