*! version 1.0.1  5nov98 arb
program define contrdlg
	version 5.0

	precmd contrdlg

	getnv
	global D_vlist "$S_1"
	getcv
	global D_vl "$S_1"

	global D_sm1 "Data variable"
	global D_sm2 "Group variable"
	global D_sm3 "Contrast coefficients"

	window control static D_sm1 5 10 60 10 left
	window control ssimple D_vlist 5 20 60 60 D_var1

	window control static D_sm2 80 10 60 10 left
	window control ssimple D_vl 80 20 60 60 D_var2

	window control static D_sm3 5 85 60 10
	window control edit 70 85 30 8 D_coef
	window control check "Trend" 110 85 30 10 D_cb1

	window control button "OK"      10 100 30 16 D_b1
	window control button "Cancel"  45 100 30 16 D_b2
	window control button "Help"    80 100 30 16 D_b3 help
	window control button "Example" 115 100 30 16 D_b4

	global D_b1 "controk"
	global D_b2 "exit 3000"
	global D_b3 "whelp contrdlg"
        global D_b4 "whelp contrsmp"

	cap noi window dialog "Contrasts in ANOVA" . . 158 135
end

program define controk
	version 5.0
	errnull "$D_var1" "A data variable"
	errnull "$D_var2" "A group variable"
	errvar "$D_var1 $D_var2"
        if "$D_coef" != "" {
		parse "$D_coef", parse(" ")
		while "`1'"!="" {
	                errrange `1' "Contrast coefficients" . .
			mac shift
		}
		local opt "coeffs($D_coef)"
	}
	else if $D_cb1 {
		local opt trend
	}
	else {
		window stopbox stop "You must give some coefficients or select a trend"
	}
	noi di in white "contrast $D_var1 $D_var2, `opt'"
	window push contrast $D_var1 $D_var2, `opt'
	contrast $D_var1 $D_var2, `opt'
	exit 3000
end
