*! version 1.0.0   arb 13jul1998
program define dplotdlg
	version 5.0

	precmd dplotdlg

	global D_run 1
        local opt ylab

	getnv
	global D_vlist "$S_1"

	global D_sm1 "Data variable"
	window control static D_sm1 5 7 55 8 left
	window control ssimple D_vlist 5 17 65 55 D_var1

	global D_sm3 "By group (optional)"
	window control static D_sm3 75 7 65 8 left
	window control ssimple D_vlist 75 17 65 55 D_by

	window control button "Draw"    3 89 30 16 D_b4
	window control button "OK"     38 89 30 16 D_b1
	window control button "Cancel" 73 89 30 16 D_b2
	window control button "Help"  108 89 30 16 D_b3 help

	global D_b1 "exit 3001"
	global D_b2 "exit 3000"
	global D_b3 "whelp dplotdlg"
	global D_b4 "dplok `opt'"

	cap noi window dialog "Dotplot" . . 150 125
	if _rc>3000 {
                dplok `opt'
	}
end

program define dplok
	version 5.0
        local opt `1'
	local wc1: word count $D_var1
	if `wc1'!=1 {
		window stopbox stop "Please specify one data variable"
	}
	local wc1: word count $D_by
	if `wc1'>1 {
		window stopbox stop "Only one by variable is allowed"
	}
	errvar "$D_var1 $D_by"
        if "$D_by" != "" {
        	local by by($D_by)
        }
	if "$D_run"!="" {
		noi di in white "dotplot $D_var1, `by' `opt'"
	}
	else {
        	noi di _n in white ". dotplot $D_var1, `by' `opt'"
        }
	global D_run
	window push dotplot $D_var1, `by' `opt'
	dotplot $D_var1, `by' `opt'
end
