*! version 1.0.1 30Oct98 arb/PR.
program define mczidlg
	version 5.0

	precmd mczidlg

	global D_sm1 "Paired test of proportions"
	global D_sm2 "Positive"
	global D_sm3 "Negative"
	global D_sm4 "State A"
	global D_sm5 "State B"
	global D_sm6 "Confidence level"

	window control static D_sm4 8 15 30 10
	window control static D_sm2 12 27 35 10
	window control static D_sm3 12 42 35 10
	window control static D_sm5 70 5 30 8
	window control static D_sm2 50 14 35 10
	window control static D_sm3 90 14 35 10
	window control static D_sm6 8 61 60 10

        * a b c d
	window control edit 50 25 29 10 D_a
	window control edit 90 25 29 10 D_b
	window control edit 50 40 29 10 D_c
	window control edit 90 40 29 10 D_d

	* Significance level and method
        window control edit 70 61 20 10 D_level
        window control radbegin "Unadjusted" 50 75 120 10 D_meth
        window control radio "Continuity correction" 50 85 120 10 D_meth
        window control radend "Exact" 50 95 120 10 D_meth

        * Buttons
      	window control button "OK"     15 112 30 16 D_bok
	window control button "Cancel" 50 112 30 16 D_bex
	window control button "Help"   85 112 30 16 D_bhl help
	window control button "Example" 120 112 30 16 D_bsmp

	global D_bhl "whelp mczidlg"
	global D_bsmp "whelp mczismp"
	global D_bok "noi tp2ok"
	global D_bex "exit 3000"

	noi capture window dialog "Paired test of proportions" . . 165 150
end

program define tp2ok
	version 5.0
	local a "State A"
	local b "State B"
	local p "positive"
	local n "negative"
	errrange "$D_a" "`a' `p', `b' `p'" 0 . "" int
	errrange "$D_b" "`a' `p', `b' `n'" 0 . "" int
	errrange "$D_c" "`a' `n', `b' `p'" 0 . "" int
	errrange "$D_d" "`a' `n', `b' `n'" 0 . "" int
	errrange "$D_level" "Confidence level" 10 99 "" int
        if $D_meth == 2 {
                local opt cc
        }
        else if $D_meth == 3 {
                local opt exact
        }
	noi di in white "mczi $D_a $D_b $D_c $D_d, level($D_level) `opt'"
	window push mczi $D_a $D_b $D_c $D_d, level($D_level) `opt'
	noi mczi $D_a $D_b $D_c $D_d, level($D_level) `opt'
        exit 3001
end
