*! version 1.0.0  19/11/98 arb
program define ptrndlg
	version 5.0
	precmd ptrndlg

	window control static D_sm1 5 5 75 8 left
	global D_sm1 "Outcome (2 groups)"
	window control ssimple D_ol 5 15 75 60 D_var1
	window control static D_sm2 85 5 75 8 left
	global D_sm2 "Group variable"
	window control ssimple D_vl 85 15 75 60 D_var2
	window control static D_sm3 165 5 75 8 left
	global D_sm3 "Score variable (optional)"
	window control ssimple D_vl 165 15 75 60 D_var3
        getbv
        global D_ol "$S_1"
	getnv
	global D_vl "$S_1"
	window control button "OK"     52 85 30 16 D_b4
	window control button "Cancel" 90 85 30 16 D_b5
	window control button "Help"   128 85 30 16 D_b6 help
        window control button "Example" 166 85 30 16 D_b7
	global D_b4 "noi ptrnok"
	global D_b5 "exit 3000"
	global D_b6 "whelp ptrndlg"
        global D_b7 "whelp ptrnsmp"
	cap noi window dialog "Test for trend in proportions" . . 250 120
end

program define ptrnok
	version 5.0
	local wc1: word count $D_var1
	local wc2: word count $D_var2
	if `wc1'+`wc2'!=2 {
		window stopbox stop "Please specify one outcome variable" "and one group variable"
	}
	errvar "$D_var1 $D_var2"
	cap confirm string var $D_var1
	if !_rc {
		window stopbox stop "$D_var1 is a string variable." /*
			*/ "Please use only a numeric outcome variable."
		exit
	}
	cap confirm string var $D_var2
	if !_rc {
		window stopbox stop "$D_var2 is a string variable." /*
			*/ "Please use only a numeric group variable."
		exit
	}
	cap confirm string var $D_var3
	if !_rc {
		window stopbox stop "$D_var3 is a string variable." /*
			*/ "Please use only a numeric group variable."
		exit
	}
	di in wh "ptrend2 $D_var1 $D_var2 $D_var3"
	window push ptrend2 $D_var1 $D_var2 $D_var3
	ptrend2 $D_var1 $D_var2 $D_var3
        exit 3000
end

