*! version 1.0.0  22/01/01 arb
* Set data as survival time
program define stdlg
	version 6.0
	cap st_is 2 analysis	// check if data is already stset
	if !_rc {
		global D_var1 : char _dta[st_bt]
		global D_var2 : char _dta[st_bd]
	}
	global D_dot
	global D_sm1 "Time variable"
	window control static D_sm1 5 5 90 15 left
	window control ssimple D_vl 5 15 70 60 D_var1
	xi
	getnv
	global D_vl "$S_1"
	global D_sm3 "Failure indicator*"
	global D_sm2 "* Variable should be coded so zero=survived, non-zero=failed. If omitted all patients assumed to have failed."
	window control static D_sm2 5 80 150 24 left
	window control static D_sm3 80 5 100 9 left
	window control ssimple D_vl 80 15 70 60 D_var2
	window control button "OK"	   25 110 30 16 D_b4
	window control button "Cancel" 60 110 30 16 D_b5
	window control button "Help"   95 110 30 16 D_b6 help
	global D_b4 "noi stok"
	global D_b5 "exit 3000"
	global D_b6 "whelp stdlg"
	cap noi window dialog "Set data as survival time" . . 160 145
end

program define stok
	version 6.0
	local wc1: word count $D_var1
	if `wc1'>0 {
		errvar "$D_var1 $D_var2"	// check variables exist
	}
	else {
		window stopbox stop "You must specify a time variable"
	}
	if !missing("$D_var2") {
		local f ", failure($D_var2)"
	}
	di in wh "stset $D_var1 `f'"
	window push stset $D_var1 `f'
	stset $D_var1 `f'
	global D_var1
	global D_var2
	exit 3000
end
